unit uMakeDirDialog;
{$INCLUDE 'NamedFoldersLite.inc'}

interface

uses
  Windows, SysUtils, Classes,
  {$IFDEF FAR3} Plugin3, {$ELSE} PluginW, {$ENDIF} FarKeysW, FarColor,
  uLog, uFAR, uMessages, uConsts;

type
  TMakeDirDialog = class(TFarDialog)
  private
    fName: string;
  private
    fEditName: integer;
    fButtonOK: integer;
    fButtonCancel: integer;
  private
    fEditNameBuf: TFarCharArray;
  protected
  public
    class function RunDialog(var Name: string): boolean;
    constructor Create;
    destructor Destroy; override;
    procedure ClearDialog; override;
    function Execute: boolean;
    property Name: string read fName write fName;
  end;

implementation

{ TMakeDirDialog }

class function TMakeDirDialog.RunDialog(var Name: string): boolean;
var
  Dialog: TMakeDirDialog;
begin
  Dialog := TMakeDirDialog.Create;
  try
    Dialog.Name := Name;
    Result := Dialog.Execute;
    if Result then
      Name := Dialog.Name;
  finally
    FreeAndNil(Dialog);
  end;
end;

procedure TMakeDirDialog.ClearDialog;
begin
  inherited;
  fEditName := -1;
  fButtonOK := -1;
  fButtonCancel := -1;
end;

constructor TMakeDirDialog.Create;
begin
  inherited Create( {$IFDEF FAR3_UP} PLUGIN_GUID, DIALOG_MAKEDIR_GUID {$ELSE} FarApi.ModuleNumber {$ENDIF} );
end;

destructor TMakeDirDialog.Destroy;
begin
  inherited;
end;

function TMakeDirDialog.Execute: boolean;
var
  Button: integer;
begin
  Result := False;
  // Build the dialog
                      AddDoubleBox(  3,  1, 62,  6, GetMsg(MTitle), 0);
                      AddLabel    (  5,  2,         GetMsg(MMakeDirName), 0);
  fEditName :=        AddEdit     (  5,  3, 54,     Name, fEditNameBuf, nil, HISTORY_NAME, 32768, DIF_HISTORY {$IFDEF FAR3_UP} or DIF_FOCUS {$ENDIF} );
                      AddLabel    (  0,  4,         nil, DIF_SEPARATOR);
  fButtonOK :=        AddButton   (  0,  5,         GetMsg(MOk), DIF_CENTERGROUP);
  fButtonCancel :=    AddButton   (  0,  5,         GetMsg(MCancel), DIF_CENTERGROUP);
  // Set focus
  {$IFNDEF FAR3_UP}
  Items[fEditName].Focus := 1;
  {$ENDIF}
  // Set the default button
  {$IFDEF FAR3_UP}
  Items[fButtonOK].Flags := Items[fButtonOK].Flags or DIF_DEFAULTBUTTON;
  {$ELSE}
  Items[fButtonOK].DefaultButton := 1;
  {$ENDIF}
  // Show the dialog
  if Build(-1, -1, 66, 8, 0, HELP_EDITOR) then begin
    if inherited Execute(Button) then begin
      if Button = fButtonOK then begin
        Name := ItemText[fEditName];
        Result := True;
      end;
    end;
  end;
end;

end.
