unit uMessages;
{$INCLUDE 'NamedFoldersLite.inc'}

interface

uses
  {$IFDEF FAR3} Plugin3, {$ELSE} PluginW, {$ENDIF} FarKeysW, FarColor,
  uSystem, uFAR, uLog,
  uConsts;

type
  TMessages = (
    MNoLngStringDefined = -1,
    //
    MTitle = 0,
    MOK,
    MCancel,
    MYes,
    MNo,
    MExceptionOccurred,
    MFolderNotDefined,
    MFolderDoesNotExist,
    MFolderAlreadyExists,
    MFolderAlreadyExistsQuestion,
    MNameMustNotBeEmpty,
    MNameContainsProhibitedCharacters,
    MConfirmDeletion,
    MDeletionFailed,
    MEditName,
    MEditDescription,
    MEditDirectory,
    MEditPluginID,
    MEditParam,
    MEditHostFile,
    MChooseName,
    MInvalidRootNode,
    MMissingNameElement,
    MEmptyNameElement,
    MMissingDirectoryElement,
    MConfirmOverwriteTitle,
    MConfirmOverwriteTagNew,
    MConfirmOverwriteTagOld,
    MConfirmOverwriteRemember,
    MConfirmOverwriteOverwrite,
    MConfirmOverwriteSkip,
    MConfirmOverwriteNamedFolder,
    MConfirmOverwriteFile,
    MDirectorySize,
    MDateTimeFormat,
    MFailedToReadFileInfo,
    MGoToNearestDirQuestion,
    MMakeDirName,
    MFailedToCreateDir,
    MFolderAlreadyExistsAndCantBeOverwritten,
    MSaveLastPanelDirectory,
    MUseSubstEngines,
    MUseSubstEngine_KnownFolders,
    MUseSubstEngine_Environment,
    MUseSubstEngine_BatchEnvironment,
    MUseSubstEngine_Registry,
    MAllowPathSuffix,
    MAllowPluginCalls,
    MAllowFuzzySearch,
    MAllowSearchOverDirectories,
    MInvalidPluginCommand,
    MInvalidPluginCall,
    MInvalidPluginCallGoto,
    MInvalidPluginCallExists,
    MInvalidPluginCallSetCurrent,
    MInvalidPluginCallSet,
    MInvalidPluginCallGet,
    MInvalidPluginCallDelete,
    MLastNamedFolderInfoDoesNotExist,
    // These must be at the end!! They are not expected to be translated
    MExtraString1,
    MExtraString2,
    MExtraString3,
    MExtraString4
  );

type
  TPFarCharArray = array of PFarChar;

function GetMsg(MsgId: TMessages): PFarChar; overload;
function GetMsg(MsgId: TMessages; const Strings: array of PFarChar): PFarChar; overload;
function GetMsgPas(MsgId: TMessages): string;
function FarMessage(const Msg: array of TMessages; Flags: TFarMessageFlags; ButtonCount: integer): integer; overload;
function FarMessage(const Msg: array of TMessages; const Strings: array of PFarChar; Flags: TFarMessageFlags; ButtonCount: integer): integer; overload;

implementation

const
  NO_MESSAGE = '';

function GetMsg(MsgId: TMessages; const Strings: array of PFarChar): PFarChar;
var
  StrIdx: integer;
begin
  if MsgId = MNoLngStringDefined then
    Result := NO_MESSAGE
  else if MsgId >= MExtraString1 then begin
    StrIdx := Integer(MsgId) - Integer(MExtraString1);
    if StrIdx < Length(Strings) then
      Result := Strings[StrIdx]
    else
      Result := NO_MESSAGE;
  end
  else
    //Result := FarApi.GetMsg( {$IFDEF FAR3_UP} PLUGIN_GUID {$ELSE} FarApi.ModuleNumber {$ENDIF} , Integer(MsgId));
    Result := TFarUtils.GetMsg(Integer(MsgId));
end;

function GetMsg(MsgId: TMessages): PFarChar;
begin
  Result := GetMsg(MsgId, []);
end;

function GetMsgPas(MsgId: TMessages): string;
begin
  Result := TFarUtils.CopyString(GetMsg(MsgId));
end;

function FarMessage(const Msg: array of TMessages; const Strings: array of PFarChar; Flags: TFarMessageFlags; ButtonCount: integer): integer;
var
  RealMsg: array of PFarChar;
  i, n: integer;
begin
  n := Length(Msg);
  SetLength(RealMsg, n);
  for i := 0 to Pred(n) do
    RealMsg[i] := GetMsg(Msg[i], Strings);
  Result := TFarUtils.ShowMessage(RealMsg, Flags, ButtonCount);
end;

function FarMessage(const Msg: array of TMessages; Flags: TFarMessageFlags; ButtonCount: integer): integer;
begin
  Result := FarMessage(Msg, [], Flags, ButtonCount);
end;

end.
